      subroutine stresscheck
      use variables
      use constants
      double precision :: strmat_store(3,3),hmat_store(3,3)
      double precision,allocatable :: rx_store(:),ry_store(:),rz_store(:)
      double precision :: inf_str

      strmat_store=strmat_set   ! Strain matrix save
                                ! (should be restored before return)

      allocate (rx_store(n),ry_store(n),rz_store(n))
      hmat_store=hmat           ! Cell matrix save
      rx_store=rx; ry_store=ry; rz_store=rz ! Atom position save

      inf_str=1.0d-5            ! Infinitesimal strain
      call calcvolume           ! Volume calculation

      call emt                  ! Cacluate dmat
      call calcstresstensor     ! Stress tensor calculation
      
!!!  sigma_xx
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(1,1)=inf_str
      call strain
      call emt
      e1=enpot
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(1,1)=-inf_str
      call strain
      call emt
      e2=enpot
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;

      stress_xx_num = 1.0d0 / v * (e1 - e2)/(inf_str * 2.0d0)

!!!  sigma_yy
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(2,2)=inf_str
      call strain
      call emt
      e1=enpot
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(2,2)=-inf_str
      call strain
      call emt
      e2=enpot
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;

      stress_yy_num = 1.0d0 / v * (e1 - e2)/(inf_str * 2.0d0)

!!!  sigma_zz
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(3,3)=inf_str
      call strain
      call emt
      e1=enpot
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(3,3)=-inf_str
      call strain
      call emt
      e2=enpot
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;

      stress_zz_num = 1.0d0 / v * (e1 - e2)/(inf_str * 2.0d0)


      write (6,'("Stress xx,yy,zz (calculated) MPa",3f14.4)') sgmmat(1,1)*1.0d-6,sgmmat(2,2)*1.0d-6,sgmmat(3,3)*1.0d-6
      write (6,'("Stress xx,yy,zz (numerical)  MPa",3f14.4)') stress_xx_num*1.0d-6,stress_yy_num*1.0d-6,stress_zz_num*1.0d-6

      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set = strmat_store
      end
      
      
