! terpotn.f
      subroutine tersoff_terpotn
      use variables
      use constants
      use bookkeep_param
      implicit double precision (a-h,o-z)
      dimension b(n,n),zeta(n,n)
      dimension xf(n,n),yf(n,n),zf(n,n)
!*----- parameter of potential -----
      elv=1.6021892d-19
      tlam1=3.2394d10
      tlam2=1.3258d10
      capa=3.2647d3*elv
      capb=9.5373d1*elv
      alp=0.0d0
      beta=3.3675d-1
      tn=2.2956d1
      c=4.8381d0
      d=2.0417d0
      h=0.0000
      tlam3=1.3258d10
      capr=3.0d-10
      capd=0.2d-10
!*      a=1.0d0
!      alx=5.43d-10/1.0d0
!      aly=5.43d-10/1.0d0
!      alz=5.43d-10/1.0d0
      alx=hmat(1,1)
      aly=hmat(2,2)
      alz=hmat(3,3)
      la=1
!*----- calculation of force & potential -----
      enpot=0.0d0
      do 100 i=1,n
         fx(i)=0.0d0
         fy(i)=0.0d0
         fz(i)=0.0d0
 100  continue
      do 1000 i=1,n
         do 2000 j=1,n
            if (i.eq.j) go to 2000
            dxij=rx(i)-rx(j)
            dyij=ry(i)-ry(j)
            dzij=rz(i)-rz(j)
            if (abs(dxij).gt.alx*dble(la)/2.0d0) then
               if (dxij.lt.0.0d0) then
                  dxij=dxij+alx*dble(la)
               else
                  dxij=dxij-alx*dble(la)
               endif
            endif
            if (abs(dyij).gt.aly*dble(la)/2.0d0) then
               if (dyij.lt.0.0d0) then
                  dyij=dyij+aly*dble(la)
               else
                  dyij=dyij-aly*dble(la)
               endif
            endif
            if (abs(dzij).gt.alz*dble(la)/2.0d0) then
               if (dzij.lt.0.0d0) then
                  dzij=dzij+alz*dble(la)
               else
                  dzij=dzij-alz*dble(la)
               endif
            endif
            rij=sqrt(dxij*dxij+dyij*dyij+dzij*dzij)
            zeta(i,j)=1.0d99
            b(i,j)=0.0d0
            if (fc(rij,capr,capd).eq.0.0d0) goto 2000
            zeta(i,j)=0.0d0
            do 3000 k=1,n
               if (k.eq.i.or.k.eq.j) go to 3000
               dxki=rx(k)-rx(i)
               dyki=ry(k)-ry(i)
               dzki=rz(k)-rz(i)
               if (abs(dxki).ge.alx*dble(la)/2.0d0) then
                  if (dxki.lt.0.0d0) then
                     dxki=dxki+alx*dble(la)
                  else
                     dxki=dxki-alx*dble(la)
                  endif
               endif
               if (abs(dyki).ge.aly*dble(la)/2.0d0) then
                  if (dyki.lt.0.0d0) then
                     dyki=dyki+aly*dble(la)
                  else
                     dyki=dyki-aly*dble(la)
                  endif
               endif
               if (abs(dzki).ge.alz*dble(la)/2.0d0) then
                  if (dzki.lt.0.0d0) then
                     dzki=dzki+alz*dble(la)
                  else
                     dzki=dzki-alz*dble(la)
                  endif
               endif
               rki=sqrt(dxki*dxki+dyki*dyki+dzki*dzki)
               costh=-(dxki*dxij+dyki*dyij+dzki*dzij)/(rki*rij)
               g=1.0d0+c*c/(d*d)-c*c/(d*d+(h-costh)*(h-costh))
               zeta(i,j)=zeta(i,j)+fc(rki,capr,capd)*g &
               *exp((tlam3*(rij-rki))**3.0)
 3000       continue
            b(i,j)=(1.0d0+(beta*zeta(i,j))**tn)**(-1.0d0/(2.0d0*tn))
!            if (i.gt.j) then
!               b(i,j)=(b(i,j)+b(j,i))/2.0d0
!               b(j,i)=b(i,j)
!            endif
 2000    continue
 1000 continue
      do 4000 i=1,n
         do 5000 j=1,n
            if (j.eq.i) go to 5000
            dxij=rx(i)-rx(j)
            dyij=ry(i)-ry(j)
            dzij=rz(i)-rz(j)
            if (abs(dxij).gt.alx*dble(la)/2.0d0) then
               if (dxij.lt.0.0d0) then
                  dxij=dxij+alx*dble(la)
               else
                  dxij=dxij-alx*dble(la)
               endif
            endif
            if (abs(dyij).gt.aly*dble(la)/2.0d0) then
               if (dyij.lt.0.0d0) then
                  dyij=dyij+aly*dble(la)
               else
                  dyij=dyij-aly*dble(la)
               endif
            endif
            if (abs(dzij).gt.alz*dble(la)/2.0d0) then
               if (dzij.lt.0.0d0) then
                  dzij=dzij+alz*dble(la)
               else
                  dzij=dzij-alz*dble(la)
               endif
            endif
            rij=sqrt(dxij*dxij+dyij*dyij+dzij*dzij)
            ffx=0.0d0
            ffy=0.0d0
            ffz=0.0d0
            xf(i,j)=0.0d0
            yf(i,j)=0.0d0
            zf(i,j)=0.0d0
!*            if (rij.ge.(capr+capd)*1.1d0) go to 5000
            if (fc(rij,capr,capd).eq.0.0d0) go to 5000
            ushtij=-fc(rij,capr,capd)*b(i,j)*capb*exp(-tlam2*rij)
            urepij=fc(rij,capr,capd)*capa*exp(-tlam1*rij)
            enpot=enpot+(ushtij+urepij)*0.5d0
            do 6000 k=1,n
               if (k.eq.i.or.k.eq.j) go to 6000
               dxki=rx(k)-rx(i)
               dyki=ry(k)-ry(i)
               dzki=rz(k)-rz(i)
               if (abs(dxki).ge.alx*dble(la)/2.0d0) then
                  if (dxki.lt.0.0d0) then
                     dxki=dxki+alx*dble(la)
                  else
                     dxki=dxki-alx*dble(la)
                  endif
               endif
               if (abs(dyki).ge.aly*dble(la)/2.0d0) then
                  if (dyki.lt.0.0d0) then
                     dyki=dyki+aly*dble(la)
                  else
                     dyki=dyki-aly*dble(la)
                  endif
               endif
               if (abs(dzki).ge.alz*dble(la)/2.0d0) then
                  if (dzki.lt.0.0d0) then
                     dzki=dzki+alz*dble(la)
                  else
                     dzki=dzki-alz*dble(la)
                  endif
               endif
               rki=sqrt(dxki*dxki+dyki*dyki+dzki*dzki)
               dxjk=-dxki-dxij
               dyjk=-dyki-dyij
               dzjk=-dzki-dzij
               rjk=sqrt(dxjk*dxjk+dyjk*dyjk+dzjk*dzjk)
!*dV_{ab}/dr_{a} [ ]
!*               costh=(rki*rki+rij*rij-rjk*rjk)/(2.0d0*rki*rij)
               if (fc(rki,capr,capd).eq.0.0d0) go to 7000
               costh=-(dxki*dxij+dyki*dyij+dzki*dzij)/(rki*rij)
               g=1.0d0+c*c/(d*d)-c*c/(d*d+(h-costh)*(h-costh))
               dvdz=capb*fc(rij,capr,capd)*exp(-tlam2*rij)*b(i,j)*beta &
                   **tn*zeta(i,j)**tn/2.0d0/(1.0d0+(beta*zeta(i,j)) &
                   **tn)/zeta(i,j)
               dzdr1=3.0d0*tlam3**3.0*fc(rki,capr,capd)*g*(rij-rki)**2.0 &
                   *exp(tlam3**3.0*(rij-rki)**3.0)
               dzdr2=(dfc(rki,capr,capd)-3.0d0*tlam3**3.0 &
                   *fc(rki,capr,capd)*(rij-rki)**2.0)*g*exp(tlam3**3.0 &
                   *(rij-rki)**3.0)
               dzdc=fc(rki,capr,capd)*exp(tlam3**3.0*(rij-rki)**3.0) &
                   *2.0d0*c**2.0*(costh-h)/(d**2.0+(h-costh)**2.0)**2.0
               dcdrx=1.0d0/rki*(dxij/rij+dxki*costh/rki) &
                   -1.0d0/rij*(dxki/rki+dxij*costh/rij)
               dcdry=1.0d0/rki*(dyij/rij+dyki*costh/rki) &
                   -1.0d0/rij*(dyki/rki+dyij*costh/rij)
               dcdrz=1.0d0/rki*(dzij/rij+dzki*costh/rki) &
                   -1.0d0/rij*(dzki/rki+dzij*costh/rij)
               ffx=ffx-dvdz*(dzdr1*dxij/rij-dzdr2*dxki/rki+dzdc*dcdrx)/2.0d0
               ffy=ffy-dvdz*(dzdr1*dyij/rij-dzdr2*dyki/rki+dzdc*dcdry)/2.0d0
               ffz=ffz-dvdz*(dzdr1*dzij/rij-dzdr2*dzki/rki+dzdc*dcdrz)/2.0d0
!*dV_{ba}/dr_{a} [ ]
!*               costh=(rij*rij+rjk*rjk-rki*rki)/(2.0d0*rij*rjk)
 7000          if (fc(rjk,capr,capd).eq.0.0d0) go to 6000
               costh=-(dxij*dxjk+dyij*dyjk+dzij*dzjk)/(rij*rjk)
               g=1.0d0+c*c/(d*d)-c*c/(d*d+(h-costh)*(h-costh))
               dvdz=capb*fc(rij,capr,capd)*exp(-tlam2*rij)*b(j,i)*beta &
                   **tn*zeta(j,i)**tn/2.0d0/(1.0d0+(beta*zeta(j,i)) &
                   **tn)/zeta(j,i)
               dzdr=3.0d0*tlam3**3.0*fc(rjk,capr,capd)*g*(rij-rjk)**2.0 &
                   *exp(tlam3**3.0*(rij-rjk)**3.0)
               dzdc=fc(rjk,capr,capd)*exp(tlam3**3.0*(rij-rjk)**3.0) &
                   *2.0d0*c**2.0*(costh-h)/(d**2.0+(h-costh)**2.0)**2.0
               dcdrx=-1.0d0/rij*(dxjk/rjk+dxij*costh/rij)
               dcdry=-1.0d0/rij*(dyjk/rjk+dyij*costh/rij)
               dcdrz=-1.0d0/rij*(dzjk/rjk+dzij*costh/rij)
               ffx=ffx-dvdz*(dzdr*dxij/rij+dzdc*dcdrx)/2.0d0
               ffy=ffy-dvdz*(dzdr*dyij/rij+dzdc*dcdry)/2.0d0
               ffz=ffz-dvdz*(dzdr*dzij/rij+dzdc*dcdrz)/2.0d0
!*dV_{bc}/dr_{a} [ ]
!*               if (rjk.gt.(capr+capd)*1.0d0) goto 6000
               dvdz=capb*fc(rjk,capr,capd)*exp(-tlam2*rjk)*b(j,k)*beta &
                   **tn*zeta(j,k)**tn/2.0d0/(1.0d0+(beta*zeta(j,k)) &
                   **tn)/zeta(j,k)
               dzdr=(dfc(rij,capr,capd)-3.0d0*tlam3**3.0 &
                   *fc(rij,capr,capd)*(rjk-rij)**2.0)*g*exp(tlam3**3.0 &
                   *(rjk-rij)**3.0)
               dzdc=fc(rij,capr,capd)*exp(tlam3**3.0*(rjk-rij)**3.0) &
                   *2.0d0*c**2.0*(costh-h)/(d**2.0+(h-costh)**2.0)**2.0
               dcdrx=-1.0d0/rij*(dxjk/rjk+dxij*costh/rij)
               dcdry=-1.0d0/rij*(dyjk/rjk+dyij*costh/rij)
               dcdrz=-1.0d0/rij*(dzjk/rjk+dzij*costh/rij)
               ffx=ffx-dvdz*(dzdr*dxij/rij+dzdc*dcdrx)/2.0d0
               ffy=ffy-dvdz*(dzdr*dyij/rij+dzdc*dcdry)/2.0d0
               ffz=ffz-dvdz*(dzdr*dzij/rij+dzdc*dcdrz)/2.0d0
 6000       continue
            dvdr1=capa*exp(-tlam1*rij)*(dfc(rij,capr,capd)-tlam1 &
                *fc(rij,capr,capd))-b(i,j)*capb*exp(-tlam2*rij) &
                *(dfc(rij,capr,capd)-tlam2*fc(rij,capr,capd))
            dvdr2=capa*exp(-tlam1*rij)*(dfc(rij,capr,capd)-tlam1 &
                *fc(rij,capr,capd))-b(j,i)*capb*exp(-tlam2*rij) &
                *(dfc(rij,capr,capd)-tlam2*fc(rij,capr,capd))
            fx(i)=fx(i)+ffx-((dvdr1+dvdr2)*dxij/rij)/2.0d0
            fy(i)=fy(i)+ffy-((dvdr1+dvdr2)*dyij/rij)/2.0d0
            fz(i)=fz(i)+ffz-((dvdr1+dvdr2)*dzij/rij)/2.0d0
 5000    continue
!         if (i.le.8) print 8100,i,fx(i)*1.0d10,fy(i)*1.0d10,fz(i)*1.0d10
 4000 continue
 8100 format (1x,i3,3d25.16)
      end
!*
!*----- cut off function f_c(r) -----
      double precision function fc(r,capr,capd)
      implicit double precision (a-h,o-z)
      pi=acos(-1.0d0)
      if (r.le.(capr-capd)) then
         fc=1.0d0
      else
         if (r.ge.(capr+capd)) then
            fc=0.0d0
         else
            fc=(1.0d0-sin(pi/2.0d0*(r-capr)/capd))/2.0d0
         endif
      endif
      return
      end
!*----- differntial of f_c(r) -----
      double precision function dfc(r,capr,capd)
      implicit double precision (a-h,o-z)
      pi=acos(-1.0d0)
      if (abs(r-capr).gt.capd) then
         dfc=0.0d0
      else
         dfc=-pi/4.0d0/capd*cos(pi/2.0d0*(r-capr)/capd)
      endif
      return
      end
